package de.fraunhofer.sit.c2x.pki.ca.module.webservice.datatypes;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;

/**
 * <p>
 * Java class for authorizationValidationResponseData complex type.
 * 
 * <p>
 * The following schema fragment specifies the expected content contained within
 * this class.
 * 
 * <pre>
 * &lt;complexType name="authorizationValidationResponseData">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="approvedCertificates" type="{http://http.ltca.pki.c2x.sit.fraunhofer.de/}approvedCertificates" maxOccurs="unbounded"/>
 *         &lt;element name="assuranceLevel" type="{http://www.w3.org/2001/XMLSchema}base64Binary"/>
 *         &lt;element name="eccPublicKeyType" type="{http://www.w3.org/2001/XMLSchema}integer"/>
 *         &lt;element name="publicKeyAlgorithm" type="{http://www.w3.org/2001/XMLSchema}integer"/>
 *         &lt;element name="requestHash" type="{http://www.w3.org/2001/XMLSchema}base64Binary"/>
 *         &lt;element name="signature" type="{http://www.w3.org/2001/XMLSchema}base64Binary"/>
 *         &lt;element name="signerInfo" type="{http://www.w3.org/2001/XMLSchema}base64Binary"/>
 *         &lt;element name="x" type="{http://www.w3.org/2001/XMLSchema}base64Binary"/>
 *         &lt;element name="y" type="{http://www.w3.org/2001/XMLSchema}base64Binary"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "authorizationValidationResponseData", propOrder = { "approvedCertificates", "assuranceLevel",
		"eccPublicKeyType", "publicKeyAlgorithm", "requestHash", "signature", "signerInfo", "x", "y" })
public class AuthorizationValidationResponseData {

	@XmlElement(required = true)
	protected List<ApprovedCertificates> approvedCertificates;
	@XmlElement(required = true)
	protected byte[] assuranceLevel;
	@XmlElement(required = true)
	protected BigInteger eccPublicKeyType;
	@XmlElement(required = true)
	protected BigInteger publicKeyAlgorithm;
	@XmlElement(required = true)
	protected byte[] requestHash;
	@XmlElement(required = true)
	protected byte[] signature;
	@XmlElement(required = true)
	protected byte[] signerInfo;
	@XmlElement(required = true)
	protected byte[] x;
	@XmlElement(required = true)
	protected byte[] y;

	public AuthorizationValidationResponseData() {
	}

	public AuthorizationValidationResponseData(List<ApprovedCertificates> approvedCertificates,
			byte[] assuranceLevel) {
		this.approvedCertificates = approvedCertificates;
		this.assuranceLevel = assuranceLevel;
	}

	/**
	 * Gets the value of the approvedCertificates property.
	 * 
	 * <p>
	 * This accessor method returns a reference to the live list, not a
	 * snapshot. Therefore any modification you make to the returned list will
	 * be present inside the JAXB object. This is why there is not a
	 * <CODE>set</CODE> method for the approvedCertificates property.
	 * 
	 * <p>
	 * For example, to add a new item, do as follows:
	 * 
	 * <pre>
	 * getApprovedCertificates().add(newItem);
	 * </pre>
	 * 
	 * 
	 * <p>
	 * Objects of the following type(s) are allowed in the list
	 * {@link ApprovedCertificates }
	 * 
	 * 
	 */
	public List<ApprovedCertificates> getApprovedCertificates() {
		if (approvedCertificates == null) {
			approvedCertificates = new ArrayList<ApprovedCertificates>();
		}
		return this.approvedCertificates;
	}

	public byte[] getAssuranceLevel() {
		return assuranceLevel;
	}

	/**
	 * Gets the value of the eccPublicKeyType property.
	 * 
	 * @return possible object is {@link BigInteger }
	 * 
	 */
	public BigInteger getEccPublicKeyType() {
		return eccPublicKeyType;
	}

	/**
	 * Sets the value of the eccPublicKeyType property.
	 * 
	 * @param value
	 *            allowed object is {@link BigInteger }
	 * 
	 */
	public void setEccPublicKeyType(BigInteger value) {
		this.eccPublicKeyType = value;
	}

	/**
	 * Gets the value of the publicKeyAlgorithm property.
	 * 
	 * @return possible object is {@link BigInteger }
	 * 
	 */
	public BigInteger getPublicKeyAlgorithm() {
		return publicKeyAlgorithm;
	}

	/**
	 * Sets the value of the publicKeyAlgorithm property.
	 * 
	 * @param value
	 *            allowed object is {@link BigInteger }
	 * 
	 */
	public void setPublicKeyAlgorithm(BigInteger value) {
		this.publicKeyAlgorithm = value;
	}

	/**
	 * Gets the value of the requestHash property.
	 * 
	 * @return possible object is byte[]
	 */
	public byte[] getRequestHash() {
		return requestHash;
	}

	/**
	 * Sets the value of the requestHash property.
	 * 
	 * @param value
	 *            allowed object is byte[]
	 */
	public void setRequestHash(byte[] value) {
		this.requestHash = value;
	}

	/**
	 * Gets the value of the signature property.
	 * 
	 * @return possible object is byte[]
	 */
	public byte[] getSignature() {
		return signature;
	}

	/**
	 * Sets the value of the signature property.
	 * 
	 * @param value
	 *            allowed object is byte[]
	 */
	public void setSignature(byte[] value) {
		this.signature = value;
	}

	/**
	 * Gets the value of the signerInfo property.
	 * 
	 * @return possible object is byte[]
	 */
	public byte[] getSignerInfo() {
		return signerInfo;
	}

	/**
	 * Sets the value of the signerInfo property.
	 * 
	 * @param value
	 *            allowed object is byte[]
	 */
	public void setSignerInfo(byte[] value) {
		this.signerInfo = value;
	}

	/**
	 * Gets the value of the x property.
	 * 
	 * @return possible object is byte[]
	 */
	public byte[] getX() {
		return x;
	}

	/**
	 * Sets the value of the x property.
	 * 
	 * @param value
	 *            allowed object is byte[]
	 */
	public void setX(byte[] value) {
		this.x = value;
	}

	/**
	 * Gets the value of the y property.
	 * 
	 * @return possible object is byte[]
	 */
	public byte[] getY() {
		return y;
	}

	/**
	 * Sets the value of the y property.
	 * 
	 * @param value
	 *            allowed object is byte[]
	 */
	public void setY(byte[] value) {
		this.y = value;
	}

}
